<template>
  <q-page class="q-pa-lg bg-grey-1">
    <div v-if="assertion">
      <q-card class="q-pb-lg shadow-1" bordered flat>

        <q-card-section class="text-weight-bold assertion__heading text-primary">
          <div><span>{{ formatted_id(assertion.id) }}</span></div>
        </q-card-section>
        <q-card-section>
          <div class="row">
            <div class="col-3 label">Aspect model</div>
            <div class="col-8 value detail_bg">{{ assertion.aspect_model }}</div>
          </div>
          <div class="row">
            <div class="col-3 label">Implicit filtering</div>
            <div class="col-8 value detail_bg">{{ assertion.implicit_filtering }}</div>
          </div>
          <div class="row">
            <div class="col-3 label">Assertion type</div>
            <div class="col-8 value detail_bg">{{ assertion.assertion_type }}</div>
          </div>
          <div class="row" v-if="assertion.test">
            <div class="col-3 label">Test</div>
          </div>
          <div class="row" v-if="assertion.test">
            <div class="col-12 value detail_bg">{{ assertion.test }}</div>
          </div>
          <div class="row" v-if="assertion.severity">
            <div class="col-3 label">Severity</div>
            <div class="col-2 value" :class="assertion.severity">{{ assertion.severity }}</div>
          </div>
          <table class="q-mt-md">
            <thead>
            <tr>
              <th>taal</th>
              <th>text</th>
              <th>role</th>
            </tr>
            </thead>
            <tbody>
            <tr v-for="label in assertion.labels" :key="label.id">
              <td style="vertical-align: top;" class="q-pr-sm">{{ label.lang }}</td>
              <td style="vertical-align: top;" class="q-pr-sm detail_bg">{{ label.label_text }}</td>
              <td style="vertical-align: top;" class="q-pr-sm">{{ label_nice_role(label) }}</td>
            </tr>
            </tbody>
          </table>
        </q-card-section>
        <q-card-section v-if="assertion.variablesets">
          <div class="text-h6">Variablesets</div>
          <div class="row">
            <div v-for="(variableset, index) of assertion.variablesets" :key="index">
              <VariablesetDetailCard :variableset="variableset"></VariablesetDetailCard>
            </div>
          </div>
        </q-card-section>

      </q-card>
    </div>
  </q-page>
</template>

<script>
import {api} from 'boot/axios'
import _ from "lodash"
import SharedMethods from "components/SharedMethods";
import VariablesetDetailCard from "components/VariablesetDetailCard";

export default {
  name: "AssertionDetail",
  components: {VariablesetDetailCard},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
  },
  props: {
    assertion_id: String,
    dts_name: String,
    nt_version: String,
  },
  data() {
    return {assertion: undefined}
  },
  watch: {
    assertion_id: function () {
      this.fetchdata()
    }
  },
  mounted() {
    this.fetchdata()
  },
  methods: {
    fetchdata: function () {
      if (this.assertion_id) {
        api
          .get("/dts/" + this.dts_name + '/assertions/' + this.assertion_id,
            {params: {nt_version: this.nt_version}})
          .then(response => {
            this.assertion = response.data[0]
          })
      }
    },
    formatted_id: function (assertion_id) {
      return assertion_id.replaceAll("_", " ")
    },

  }
}
</script>

<style scoped lang="scss">
.assertion__heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
  margin-bottom: 10px;
}

.value {
  border-radius: 5px;
  padding: 5px 0 5px 10px;
}

.ERROR {
  background-color: $red;
  color: white;
}

.WARNING {
  background-color: $orange-3;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

table {
  border-spacing: 5px;
  border-collapse: collapse;
  width: 100%;
}

th {
  text-align: left;
}

td, th {
  border: 1px solid $detail_bg;
  padding: 3px 5px;
}

td.tiny {
  width: 10%;
}
</style>
